import * as React from 'react';
import classnames from 'classnames';
import Touchable from 'reactui-mobile-mobile-touchable';
import 'reactui-mobile-mobile-styles/lib/Icon';
var prefixCls = 'amd-icon';

var Icon = function Icon(props) {
  var type = props.type,
      className = props.className,
      size = props.size,
      color = props.color,
      onPress = props.onPress;
  var cls = classnames(className, prefixCls, prefixCls + "-" + type, prefixCls + "-" + size);
  return /*#__PURE__*/React.createElement(Touchable, {
    onPress: onPress
  }, /*#__PURE__*/React.createElement("svg", {
    className: cls,
    color: color
  }, /*#__PURE__*/React.createElement("use", {
    xlinkHref: "#" + type
  })));
};

Icon.displayName = 'BaseIcon';
Icon.defaultProps = {
  size: 'md'
};
export default Icon;